#!/usr/bin/perl

$usage =
"Usage: mkpst2.pl [-hZ]

    -h: show this help
    -Z: output Zenkaku digit as zip code
";

if ($ARGV[0] eq '-h'){
  print STDERR "$usage";
  exit;
}

undef $opt_Z;
for(;$#ARGV>=0;shift){
  if($ARGV[0] eq '-Z'){
    shift;
    $opt_Z=1;
  }
}

print "\\comment ͹ֹ(from_ken_all.csv_on_http://www.postal.mpt.go.jp/down_2.htm)\n";
print "\\total 0\n";
print "\\hinsi\n";
print "\n";

while (<>) {
  s/\"//g;
  split(/,/, $_);
  $_[2] =~ s/[ \t]//g;
  $_[3] =~ tr/\xa5a1-\xa5f3/\xa4a1-\xa4f3/; # Katakana -> Hiragana for EUC
  $_[4] =~ tr/\xa5a1-\xa5f3/\xa4a1-\xa4f3/; # Katakana -> Hiragana for EUC
  $_[5] =~ tr/\xa5a1-\xa5f3/\xa4a1-\xa4f3/; # Katakana -> Hiragana for EUC
  $_[8] = 'ʤ¾' if ($_[8] eq 'ʲ˷Ǻܤʤ');
  $_[2] = &to_Zenkaku_digit($_[2]) if defined $opt_Z;
  push(@lines, "$_[2] $_[6]$_[7]$_[8]  ̾ 0\n");
}

foreach $l (sort @lines) {
  print $l;
}

sub to_Zenkaku_digit{
  local($_) = @_;

  # 0123456789 -> 
  s/0//g;
  s/1//g;
  s/2//g;
  s/3//g;
  s/4//g;
  s/5//g;
  s/6//g;
  s/7//g;
  s/8//g;
  s/9//g;
  return $_;
}
